
% This document demonstrate the use of the module-id command
% Author: John-Olof Nilsson

% Clear workspace
clear all, clc, close all

% Open serial port
% CHANGE THIS TO WHATEVER SERIAL PORT YOUR DEVICE IS CONNECTED AS!
com = serial('COM6');
fopen(com);

% Ping the module
command = [4 0 4]
fwrite(com,command,'uint8');

% Wait a little bit
pause(1);

% Read the response
acknowledgement = fread(com,4,'uint8')'
response = fread(com,com.BytesAvailable,'uint8')'
disp(' ');
header = response(1)
package_number = response(2:3)
payload_size = response(4)
your_module_id = response(5:19)

% Close serial port and file
fclose(com);
