
% This script demonstrate the use of the set_state_max_Xbytes commands
% Author: John-Olof Nilsson

% Clear workspace
clear all, clc, close all

% Open serial port
% CHANGE THIS TO WHATEVER SERIAL PORT YOUR DEVICE IS CONNECTED AS!
com = serial('COM47','ByteOrder','bigEndian');
fopen(com);

% Set state (1 byte)
header = 18;
state = 37; % Filter reset flag
value = 1;
command = [header state value];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
% Retrieve state
header = 32;
state = 37;
pull_state = 32;
command = [header state pull_state];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
response = fread(com,4+1+2,'uint8');
fprintf('Set value: %i, retrieved value %i\n',value,response(5));


% Set state (4 bytes)
header = 19;
state = 21; % Zero-velocity test statistics
value = [2 1 1 1];
command = [header state value];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
% Retrieve state
header = 32;
pull_state = 32;
command = [header state pull_state];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
fread(com,4,'uint8');
response = fread(com,1,'uint32');
fread(com,2,'uint8');
fprintf('Set value: %i, retrieved value %i\n',2^24*value(1)+2^16*value(2)+2^8*value(3)+value(4),response);


% Set state (12 bytes)
header = 20;
state = 32; % Position states
value = [1 1 1 1  1 1 1 1  1 1 1 1];
command = [header state value];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
% Retrieve state
header = 32;
pull_state = 32;
command = [header state pull_state];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
fread(com,4,'uint8');
response = fread(com,12,'uint8')';
fread(com,2,'uint8');
disp(value);
disp(response);

% Set state (24 bytes)
header = 21;
state = 17; % Combined inertial readings
value = [1 1 1 1  1 1 1 1  1 1 1 1  1 1 1 1  1 1 1 1  1 1 1 1];
command = [header state value];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
% Retrieve state
header = 32;
pull_state = 32;
command = [header state pull_state];
command = [command (sum(command)-mod(sum(command),256))/256 mod(sum(command),256)];
fwrite(com,command,'uint8');
fread(com,4,'uint8');
fread(com,4,'uint8');
response = fread(com,24,'uint8')';
fread(com,2,'uint8');
disp(value);
disp(response);

% Close serial port and file
fclose(com);
