
% Clear workspace
clear all, clc, close all

% Open serial port
com = serial('COM6', 'BaudRate', 460800,'InputBufferSize',10000);
fopen(com);

% Open binary file for saving inertial data
file = fopen('imu_data.bin', 'w');

% Tell OpenShoe to output inertial data at every interrupt

fwrite(com,[32 32 12 0 76],'uint8');
fread(com,4,'uint8')

% Open dummy figure with pushbutton such that logging can be aborted
abort = 0;
figure;
uicontrol('style','push','string','Abort data logging','callback','abort=1;');
drawnow

while abort==0
    if com.BytesAvailable>0
        fread(com,com.BytesAvailable,'uint8')
    end
    drawnow
end

abort=0;

fwrite(com,[32 33 10 0 75],'uint8');
fread(com,4,'uint8')

while abort==0
    if com.BytesAvailable>0
        fread(com,com.BytesAvailable,'uint8')
    end
    drawnow
end

abort=0;

fwrite(com,[32 24 11 0 67],'uint8');
fread(com,4,'uint8')

while abort==0
    if com.BytesAvailable>0
        fread(com,com.BytesAvailable,'uint8')
    end
    drawnow
end

% Logg data until pushbutton pressed
% nr_bytes = 0;
% while abort==0
%     if com.BytesAvailable>0
%         nr_bytes = nr_bytes + fwrite(file,fread(com,com.BytesAvailable,'uint8'),'uint8');
%     end
%     drawnow
% end

% Stop output
fwrite(com,[33 0 33],'uint8');
fread(com,4,'uint8')

% Close serial port and file
fclose(com);
fclose(file);
% 
% 
% % OPEN AND DISPLAY DATA
% file = fopen('imu_data.bin','r');
% 
% % rx = fread(file,'uint8');
% % disp(rx')
% % fseek(file,0,'bof');
% 
